Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Interpreter.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Interpreter.cs	(revision 9260)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Interpreter.cs	(revision 9262)
@@ -11,4 +11,6 @@
 using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using HeuristicLab.Problems.DataAnalysis;
+using System.Threading;
+using HeuristicLab.Problems.TradeRules.Symbols;
 
 namespace HeuristicLab.Problems.TradeRules
@@ -16,22 +18,25 @@
     [StorableClass]
     [Item("Interpreter", "Represents a grammar for Trading Problems")]
-    public sealed class Interpreter : ParameterizedNamedItem, ISymbolicDataAnalysisExpressionTreeInterpreter
+    public sealed class Interpreter : ParameterizedNamedItem, ITradeRulesExpresionTree
     {
         private const string CheckExpressionsWithIntervalArithmeticParameterName = "CheckExpressionsWithIntervalArithmetic";
         private const string EvaluatedSolutionsParameterName = "EvaluatedSolutions";
+        private int initialTraining;
+        private int initialTest;
         [ThreadStatic]
-        private static double [] EMAValue;
+        private static Dictionary<ISymbolicExpressionTreeNode, double> signalCache;
         [ThreadStatic]
-        private static double inOut;
+        private static Dictionary<ISymbolicExpressionTreeNode, double> firstEMACache;
         [ThreadStatic]
-        private static double meanUp;
+        private static Dictionary<ISymbolicExpressionTreeNode, double> secondEMACache;
         [ThreadStatic]
-        private static double meanDown;
+        private static Dictionary<ISymbolicExpressionTreeNode, double> RSIPositiveCache;
         [ThreadStatic]
-        private static double lastRSI;
-		
-		// [ThreadStatic]
-		// private Dictionary<Instruction, double> lastEMACache;
-		
+        private static Dictionary<ISymbolicExpressionTreeNode, double> RSINegativeCache;
+        [ThreadStatic]
+        private static Dictionary<ISymbolicExpressionTreeNode, double> RSICache;
+        [ThreadStatic]
+        private static Dictionary<ISymbolicExpressionTreeNode, double> RSIOutputCache;
+
         #region private classes
         //This class manipulate the instructions of the stack
@@ -133,7 +138,4 @@
             public const byte Lag = 19;
             public const byte RSI = 20;
-            public const byte EMA = 21;
-            
-
         }
         #endregion
@@ -165,5 +167,4 @@
       { typeof(MACD), OpCodes.MACD},
       { typeof(RSI), OpCodes.RSI},
-      { typeof(EMA), OpCodes.EMA},
       { typeof(Max), OpCodes.Max},
       { typeof(Min), OpCodes.Min},
@@ -251,5 +252,5 @@
                         if (row < integerValue)
                         {
-                            string variableName = dataset.GetValue(row, 2);
+                            string variableName = dataset.GetValue(row, 3);
                             double inferiorValue = Convert.ToDouble(variableName);
                             return inferiorValue/(row+1);
@@ -257,63 +258,10 @@
                         else
                         {
-                            string variableName = dataset.GetValue(row, 2);
+                            string variableName = dataset.GetValue(row, 3);
                             double meanValue1 = Convert.ToDouble(variableName);
-                            string variableName2 = dataset.GetValue((row - integerValue), 2);
+                            string variableName2 = dataset.GetValue((row - integerValue), 3);
                             double meanValue2 = Convert.ToDouble(variableName2);
                             return (meanValue1 - meanValue2) / integerValue;
                         }
-                    }
-                case OpCodes.MACD:
-                    {                 
-                        /*double firstMean = Evaluate(dataset, ref row, state);
-                        double secondMean = Evaluate(dataset, ref row, state);
-                        double signal = Evaluate(dataset, ref row, state);
-                        double firstEMA = 0.0;
-                        double secondEMA = 0.0;
-                        double lastFirstEMA = 0.0;
-                        double lastSecondEMA = 0.0;
-                        double macd = 0.0;
-                        double firstFactor = 0.0;
-                        double signalValue = Double.NegativeInfinity;
-                        if (row == (firstMean - 1))
-                        {
-                            string variableName = dataset.GetValue(row, 2);
-                            double meanValue1 = Convert.ToDouble(variableName);
-                            firstEMA = meanValue1 / firstMean;
-                        }
-                        if (row == (secondMean-1))
-                        {
-                            string variableName = dataset.GetValue(row, 2);
-                            double meanValue2 = Convert.ToDouble(variableName);
-                            secondEMA = meanValue2 / secondMean;
-                        }
-                        string variableName2 = dataset.GetValue(row, 1);
-                        double intValue = Convert.ToDouble(variableName2);
-                        if (row > (firstMean-1))
-                        {
-                              firstFactor = 2 / (firstMean + 1);                          
-                              firstEMA = (intValue * firstFactor) + (lastFirstEMA * (1-firstFactor));
-                        }
-                            if (row > (secondMean-1))
-                            {
-                                double secondFactor = 2 / (secondMean + 1);
-                                secondEMA = (intValue * secondFactor) + (lastSecondEMA * (1 - secondFactor));      
-                            }
-                            lastFirstEMA = firstEMA;
-                            lastSecondEMA = secondEMA;
-                            macd = firstEMA - secondEMA;
-                        if ((row < (firstMean-1)) || (row < (secondMean-1))) return 0.0;
-                        else return macd;*/
-                        return 0.0;
-
-                        //macd = firstEMA - secondEMA;
-                        //if (row == Math.Max(firstMean, secondMean)) signalValue = macd;
-                        //if (row > firstMean && row > secondMean)
-                        //{
-                        //    double factor = 2 / (signal + 1);
-                        //    signalValue = (macd * factor) + (lastSignal * (1 - factor));
-                        //}
-                        //if (!Double.IsNegativeInfinity(signalValue)) lastSignal = signalValue;
-                        //return signalValue > macd ? 1.0 : -1.0;
                     }
                 case OpCodes.AND:
@@ -374,32 +322,4 @@
                         return ((IList<double>)currentInstr.iArg0)[row] * variableTreeNode.Weight;
                     }
-                case OpCodes.EMA:
-                    {
-                        //I assume you want to calculate the EMA as defined at http://en.wikipedia.org/wiki/Moving_average#Exponential_moving_average
-						//for the mean value saved at position 1 of the dataset
-						//and timevalue specifies how many days you want to include in your EMA
-						double timeValue = (int)Evaluate(dataset, ref row, state);
-
-						// with caching
-						// if (lastEmaCache.ContainsKey(currentInst)
-						//   lastEma = lastEmaCache[currentInstr]
-						// else 
-						//   lastEma = 1;
-						
-						//get all mean values from row - timeValue up to the actual row
-						double[] meanValues = dataset.GetDoubleValues("insert variable name", Enumerable.Range(row - (int)timeValue, timeValue)).ToArray();
-
-						double EMA = meanValues[0];
-						double factor = 2.0 / (timeValue + 1.0);
-
-						for (int i = 1; i < timeValue; i++) {
-						  EMA = meanValues[i] * factor + (1 - factor) * EMA;
-						}
-						
-						// save in cache for next evaluation
-						// lastEmaCache[currentInstr] = EMA;
-						
-						return EMA;
-                    }
                 case OpCodes.Constant:
                     {
@@ -425,5 +345,5 @@
                         {
                             int position = row - i;
-                            string variableName = dataset.GetValue(position, 1);
+                            string variableName = dataset.GetValue(position, 2);
                             double intValue = Convert.ToDouble(variableName);
                             if (intValue>max) max = intValue;
@@ -440,5 +360,5 @@
                         {
                             int position = row - i;
-                            string variableName = dataset.GetValue(position, 1);
+                            string variableName = dataset.GetValue(position, 2);
                             double intValue = Convert.ToDouble(variableName);
                             if (intValue < min) min = intValue;
@@ -452,60 +372,160 @@
                         if (n>row) return 0;
                         int position = row - n;
-                        string variableName = dataset.GetValue(position, 1);
+                        string variableName = dataset.GetValue(position, 2);
                         double intValue = Convert.ToDouble(variableName);
                         return intValue;
                     }
+                case OpCodes.MACD:
+                    {
+                        var MACDNode = currentInstr.dynamicNode;
+                        //Taking the number of the days for each EMA
+                        double firstEMA = Evaluate(dataset, ref row, state);
+                        double secondEMA = Evaluate(dataset, ref row, state);
+                        double signal = Evaluate(dataset, ref row, state);
+
+                        //Calculating the factor for each EMA
+                        double factor = 2.0 / (firstEMA + 1.0);
+                        double factor2 = 2.0 / (secondEMA + 1.0);
+                        double factor3 = 2.0 / (signal + 1.0);
+
+                        //Initiation of the variables
+                        double firstElementEMA = -1000000;
+                        double secondElementEMA = -100000;
+                        double signalValue = -100000;
+                        double macd = 0;
+
+                        //Check if this MACD has previous values and retrieve them
+                        if (firstEMACache.ContainsKey(MACDNode)) firstElementEMA = firstEMACache[MACDNode];
+                        if (secondEMACache.ContainsKey(MACDNode)) secondElementEMA = secondEMACache[MACDNode];
+                        if (signalCache.ContainsKey(MACDNode)) signalValue = signalCache[MACDNode];
+
+                        //Calculate the first value in the training for the two EMAs and the signal.
+                        if (row <= initialTraining || row == initialTest)
+                        {
+                            double[] meanValues = dataset.GetDoubleValues("\"Close\"", Enumerable.Range(0, (row + 1))).ToArray();
+                            firstElementEMA = meanValues[0];
+                            secondElementEMA = meanValues[0];
+                            double max = (Math.Max(firstEMA, secondEMA) - 1);//The first macd happens when the longest EMA has its first value. We need -1 because row begin in 0.
+                            for (int i = 1; i <= row; i++)
+                            {
+                                firstElementEMA = meanValues[i] * factor + (1 - factor) * firstElementEMA;
+                                secondElementEMA = meanValues[i] * factor2 + (1 - factor2) * secondElementEMA;
+                                if (i == max) signalValue = firstElementEMA - secondElementEMA;//First signal equals to macd.
+                                else if (i > max)//Calculation for the next signals
+                                {
+                                    macd = firstElementEMA - secondElementEMA;
+                                    signalValue = macd * factor3 + (1 - factor3) * signalValue;
+                                }
+                            }
+                        }
+                        else  //The rest of the rows are calculating with the standard EMA formula
+                        {
+                            //Retrieve the dataset values 
+                            string variableName = dataset.GetValue(row, 2);
+                            double meanValue1 = Convert.ToDouble(variableName);
+
+                            //Calculating EMA
+                            firstElementEMA = meanValue1 * factor + (1 - factor) * firstElementEMA;
+                            secondElementEMA = meanValue1 * factor2 + (1 - factor2) * secondElementEMA;
+
+                            //Calculating signal
+                            macd = firstElementEMA - secondElementEMA;
+                            signalValue = macd * factor3 + (1 - factor3) * signalValue;
+                        }
+
+                        //Save the values for the next iteration
+                        firstEMACache[MACDNode] = firstElementEMA;
+                        secondEMACache[MACDNode] = secondElementEMA;
+                        signalCache[MACDNode] = signalValue;
+
+                        macd = firstElementEMA - secondElementEMA;
+                        return macd > signalValue ? 1.0 : -1.0;
+                    }
                 case OpCodes.RSI:
-                    {
-                        /*
-                        double numberOfDays = Evaluate(dataset, ref row, state);
-                        double todayRSI=0.0;
-                        if (numberOfDays > row) return 0.0;
-                        else
-                        {
-                            double addUp = 0;
-                            double addDown = 0;
-                            double change=0;
-                            if (row == (numberOfDays))
-                            {
-                                for (int k = 1; k < (numberOfDays+1); k++)
-                                {
-                                    string variableName = dataset.GetValue(k, 1);
-                                    double intValue = Convert.ToDouble(variableName);
-                                    variableName = dataset.GetValue((k - 1), 1);
-                                    double intValue2 = Convert.ToDouble(variableName);
-                                     change = intValue - intValue2;
-                                    if (change > 0) addUp = addUp + change;
-                                    else addDown = addDown - change;
-                                  
-                                }
-                                meanUp = addUp / numberOfDays;
-                                meanDown = addDown / numberOfDays;
-                                if (meanDown != 0) todayRSI = 100 - (100 / (1 + (meanUp / meanDown)));
-                                else todayRSI = 100;
-                             }
-                            else
-                            {
-                                string variableName = dataset.GetValue(row, 1);
-                                double intValue = Convert.ToDouble(variableName);
-                                variableName = dataset.GetValue((row - 1), 1);
-                                double intValue2 = Convert.ToDouble(variableName);
-                                change = intValue - intValue2;
-
-                                addUp = meanUp * (numberOfDays - 1);
-                                addDown = meanDown * (numberOfDays - 1);
-                                if (change > 0) addUp = addUp + change;
-                                else addDown = addDown - change;
-                                meanUp = addUp / numberOfDays;
-                                meanDown = addDown / numberOfDays;
-                                if (meanDown != 0) todayRSI = 100 - (100 / (1 + (meanUp / meanDown)));
-                                else todayRSI = 100;
-                            }
-                        }
-                        if ((lastRSI < 70) && (todayRSI >= 70)) inOut = 1;
-                        else if((lastRSI > 30) && (todayRSI <= 30)) inOut=-1;
-                        lastRSI = todayRSI;*/
-                        return 0.0;
-                        
+                   {
+                       
+                       //Taking the number of the days for EMA
+                       double numberOfDays = Evaluate(dataset, ref row, state);
+
+                       //Calculate the factor for the EMA
+                       double factor = 1.0 / numberOfDays;
+
+                       double positiveEMA = 0;
+                       double negativeEMA = 0;
+                       double yesterdayRSI = double.NegativeInfinity;
+                       double todayRSI = double.NegativeInfinity;
+                       double outputRSI = double.NegativeInfinity;
+                       //Retrieve EMA values
+                       if (RSIPositiveCache.ContainsKey(currentInstr.dynamicNode)) positiveEMA = RSIPositiveCache[currentInstr.dynamicNode];
+                       if (RSINegativeCache.ContainsKey(currentInstr.dynamicNode)) negativeEMA = RSINegativeCache[currentInstr.dynamicNode];
+                       if (RSICache.ContainsKey(currentInstr.dynamicNode)) yesterdayRSI = RSICache[currentInstr.dynamicNode];
+                       if (RSIOutputCache.ContainsKey(currentInstr.dynamicNode)) outputRSI = RSIOutputCache[currentInstr.dynamicNode];
+
+                       if (row == initialTraining || row == initialTest)
+                       {
+                           double[] closeValues = dataset.GetDoubleValues("\"Close\"", Enumerable.Range(0, (row + 1))).ToArray();
+                           outputRSI = -1.0;
+                           for (int i = 1; i <= row; i++)
+                           {
+                               if (numberOfDays>=i)
+                               {
+                                   if ((closeValues[i] - closeValues[i - 1]) > 0) positiveEMA = ((closeValues[i] - closeValues[i - 1])+positiveEMA);
+                                   else negativeEMA = Math.Abs(closeValues[i] - closeValues[i - 1]) + negativeEMA;
+                                   if (numberOfDays == i)
+                                   {
+                                       positiveEMA = positiveEMA/numberOfDays;
+                                       negativeEMA = negativeEMA / numberOfDays;
+                                       yesterdayRSI = 100 - (100 / (1 + (positiveEMA / negativeEMA)));
+                                   }
+                               }else{
+                                    if ((closeValues[i] - closeValues[i - 1]) > 0)
+                                    {
+                                        positiveEMA = (closeValues[i]-closeValues[i-1]) * factor + (1 - factor) * positiveEMA;
+                                        negativeEMA = 0 * factor + (1 - factor) * negativeEMA;
+                                    }
+                                    else
+                                    {
+                                        positiveEMA = 0 * factor + (1 - factor) * positiveEMA;
+                                        negativeEMA = Math.Abs(closeValues[i] - closeValues[i - 1]) * factor + (1 - factor) * negativeEMA;
+                                    }
+                                   
+                                    todayRSI = 100 - (100 / (1 + (positiveEMA / negativeEMA)));
+
+                                    if ((yesterdayRSI < 30) && (todayRSI > 30)) outputRSI = 1.0;
+                                   else if ((yesterdayRSI > 70) && (todayRSI < 70)) outputRSI = -1.0;
+                                   yesterdayRSI = todayRSI;
+                               }
+                           }
+                       }
+                       else
+                       {
+                           string todayCloseString = dataset.GetValue(row, 2);
+                           string yesterdayCloseString = dataset.GetValue((row - 1), 2);
+                           double todayClose = Convert.ToDouble(todayCloseString);
+                           double yesterdayClose = Convert.ToDouble(yesterdayCloseString);
+
+                           //Calculating EMA
+                           if ((todayClose - yesterdayClose) > 0)
+                           {
+                               positiveEMA = (todayClose-yesterdayClose) * factor + (1 - factor) * positiveEMA;
+                               negativeEMA = 0 * factor + (1 - factor) * negativeEMA;
+                           }
+                           else
+                           {
+                               positiveEMA = 0 * factor + (1 - factor) * positiveEMA;
+                               negativeEMA = Math.Abs(todayClose - yesterdayClose) * factor + (1 - factor) * negativeEMA;
+                           }
+                           todayRSI = 100 - (100 / (1 + (positiveEMA / negativeEMA)));
+                           if ((yesterdayRSI < 30) && (todayRSI > 30)) outputRSI = 1.0;
+                           else if ((yesterdayRSI > 70) && (todayRSI < 70)) outputRSI = -1.0;
+                       }
+                       
+                       //Save positive and negative EMA for the next iteration
+                       RSIPositiveCache[currentInstr.dynamicNode] = positiveEMA;
+                       RSINegativeCache[currentInstr.dynamicNode] = negativeEMA;
+                       RSICache[currentInstr.dynamicNode] = todayRSI;
+                       RSIOutputCache[currentInstr.dynamicNode] = outputRSI;   
+                       
+                       return outputRSI;
                     }
                 
@@ -553,10 +573,30 @@
                 Parameters.Add(new ValueParameter<IntValue>(EvaluatedSolutionsParameterName, "A counter for the total number of solutions the interpreter has evaluated", new IntValue(0)));
         }
-        
+        public void setInitialTraining(int initialTraining)
+        {
+            this.initialTraining = initialTraining;
+        }
+
+        public void setInitialTest(int initialTest)
+        {
+            this.initialTest = initialTest;
+        }
+
+        public void clearVariables()
+        {
+            signalCache.Clear();
+            firstEMACache.Clear();
+            secondEMACache.Clear();
+            RSIPositiveCache.Clear();
+            RSINegativeCache.Clear();
+            RSICache.Clear();
+            RSIOutputCache.Clear();
+        }
+
         //Take the symbolic expression values of the tree
         public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, Dataset dataset, IEnumerable<int> rows)
         {
             if (CheckExpressionsWithIntervalArithmetic.Value)
-                throw new NotSupportedException("Interval arithmetic is not yet supported in the symbolic data analysis interpreter.");
+            throw new NotSupportedException("Interval arithmetic is not yet supported in the symbolic data analysis interpreter.");
             EvaluatedSolutions.Value++; // increment the evaluated solutions counter
             var compiler = new SymbolicExpressionTreeCompiler();
@@ -572,24 +612,28 @@
                     code[i] = instr;
                 }
-                else if (instr.opCode == OpCodes.EMA)
-                {
-                    instr.iArg0 = EMAValue;
+            }
+
+
+            if (signalCache == null) signalCache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+            if (firstEMACache == null) firstEMACache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+            if (secondEMACache == null) secondEMACache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+            if (RSIPositiveCache == null) RSIPositiveCache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+            if (RSINegativeCache == null) RSINegativeCache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+            if (RSICache == null) RSICache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+            if (RSIOutputCache == null) RSIOutputCache = new Dictionary<ISymbolicExpressionTreeNode, double>();
+                                 
+                                       
+                                        var state = new InterpreterState(code, necessaryArgStackSize);
+                                        //Evaluate each row of the datase
+                                        foreach (var rowEnum in rows)
+                                        {
+                                            int row = rowEnum;
+                                            state.Reset();
+                                            if (row < initialTraining) yield return -1;
+                                            else yield return Evaluate(dataset, ref row, state);
+                                        }
                 }
-            }
-			
-			// with caching
-			// if (lastEmaCache == null) lastEmaCache = new Dictionary<Instruction, double>();
-			// else lastEmaCache.Clear();
-			
-            var state = new InterpreterState(code, necessaryArgStackSize);
-            //Evaluate each row of the datase
-            foreach (var rowEnum in rows)
-            {
-                int row = rowEnum;
-                state.Reset();
-                yield return Evaluate(dataset, ref row, state);
-            }
         }
 
     }
-}
+
